
#ifdef __hsp30__

;---------- ---------- ---------- ---------- ---------- ----------

#ifndef __KERNEL32__
#define global __KERNEL32__
#uselib "KERNEL32.DLL"
	#func global LoadLibrary "LoadLibraryA" sptr
	#func global FreeLibrary "FreeLibrary" sptr
#endif

;---------- ---------- ---------- ---------- ---------- ----------

#ifndef __USER32__
#define global __USER32__
#uselib "USER32.DLL"
	#define global AppendMenu AppendMenuA
	#func global AppendMenuA "AppendMenuA" sptr,sptr,sptr,sptr
	#func CheckMenuItem "CheckMenuItem" sptr,sptr,sptr
	#func global CreateMenu "CreateMenu"
	#func global CreatePopupMenu "CreatePopupMenu"
	#func global CreateWindowEx "CreateWindowExA" sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr,sptr
	#func global DrawMenuBar "DrawMenuBar" sptr
	#cfunc global GetWindowLong "GetWindowLongA" sptr,sptr
	#func global SetMenu "SetMenu" sptr,sptr
	#func global SetWindowLong "SetWindowLongA" sptr,sptr,sptr
	#func global SetWindowPos "SetWindowPos" sptr,sptr,sptr,sptr,sptr,sptr,sptr
	#func global GetForegroundWindow "GetForegroundWindow"
	#func global GetWindowRect "GetWindowRect" sptr,sptr
#endif

;---------- ---------- ---------- ---------- ---------- ----------

#ifndef __SHELL32__
#define global __SHELL32__
#uselib "SHELL32.DLL"
	#func global DragAcceptFiles "DragAcceptFiles" sptr,sptr
	#func global DragFinish "DragFinish" sptr
	#func global DragQueryFile "DragQueryFile" sptr,sptr,sptr,sptr
#endif

;---------- ---------- ---------- ---------- ---------- ----------

#endif



;---------- ---------- ---------- ---------- ---------- ----------

#define global WM_SIZE          0x0005 ;EBhETCYύX
#define global WM_ACTIVATE      0x0006 ;ANeBuON/OFF
#define global WM_SETTEXT       0x000C ;eLXgݒ
#define global WM_GETTEXTLENGTH 0x000E ;eLXg̃TCY擾
#define global WM_GETTEXT       0x000D ;eLXg擾
#define global WM_COMMAND       0x0111 ;j[ACȇIERg[̒ʒm
#define global WM_CUT           0x0300 ;(GfB^)eLXg̐؂
#define global WM_COPY          0x0301 ;(GfB^)eLXg̃Rs[
#define global WM_CLEAR         0x0303 ;(GfB^)eLXg̍폜
#define global WM_PASTE         0x0302 ;(GfB^)eLXg̓\t 
#define global WM_UNDO          0x0304 ;(GfB^)ɖ߂

;---------- ---------- ---------- ---------- ---------- ----------

#define global EM_GETSEL              0xB0 ;IꂽeLXg̍ŏƍŌ̕CfbNX擾
#define global EM_SETSEL              0xB1 ;w肵͈͂̃eLXgIԂɂ
#define global EM_GETRECT             0xB2 ;eLXg{bNX̃tH[}bg̈̋`擾
#define global EM_SETRECT             0xB3 ;eLXg{bNX̃tH[}bg̈̋`ݒ
#define global EM_SETRECTNP           0xB4 ;eLXg{bNX̃tH[}bg̈̋`ݒ
#define global EM_SCROLL              0xB5 ;seLXg{bNXɂāAeLXg̃XN[s
#define global EM_LINESCROLL          0xB6 ;sTextBoxɂāAeLXgXN[
#define global EM_SCROLLCARET         0xB7 ;sTextBoxɂāAeLXgIƂALbgXN[
#define global EM_GETMODIFY           0xB8 ;eLXg{bNX̓eύXĂ邩ǂ𔻒f
#define global EM_SETMODIFY           0xB9 ;eLXg{bNX̓e̍XVԂݒ
#define global EM_GETLINECOUNT        0xBA ;sTextBoxɂāAeLXg̍s擾
#define global EM_LINEINDEX           0xBB
#define global EM_SETHANDLE           0xBC
#define global EM_GETHANDLE           0xBD ;sTextBox̃eLXgɊ蓖Ăꂽ̈̃nh擾
#define global EM_GETTHUMB            0xBE ;sTextBoxɂāAXN[o[̈ʒu擾

#define global EM_LINELENGTH          0xC1 ;sTextBoxɂāAw肵sCfbNẌO̍s܂ł̃oCg擾
#define global EM_REPLACESEL          0xC2 ;ݑIĂeLXgw̃eLXgŒu
#define global EM_GETLINE             0xC4 ;sTextBoxɂāAw̍s擾
#define global EM_LIMITTEXT           0xC5 ;͂ł镶𐧌
#define global EM_SETLIMITTEXT        0xC5 ;EM_LIMITTEXTƓ
#define global EM_CANUNDO             0xC6 ;EM_UNDO\ǂ𔻒f
#define global EM_UNDO                0xC7 ;Ȏɖ߂(UNDO@\)
#define global EM_FMTLINES            0xC8 ;sTextBoxɂāA\tgsݒE폜
#define global EM_LINEFROMCHAR        0xC9 ;sTextBoxɂāAw̕CfbNX܂ލsCfbNX擾
#define global EM_SETTABSTOPS         0xCB ;seLXg{bNX̃^uXgbvʒuݒ
#define global EM_SETPASSWORDCHAR     0xCC ;݂̃pX[hݒ
#define global EM_EMPTYUNDOBUFFER     0xCD ;UNDOtONA
#define global EM_GETFIRSTVISIBLELINE 0xCE ;gbvɕ\Ăsԍ擾
#define global EM_SETREADONLY         0xCF ;eLXg{bNXҏWłȂ悤ɐݒ

#define global EM_SETWORDBREAKPROC    0xD0 ;GfBbg Rg[ŎgJX^̃[h u[N
#define global EM_GETWORDBREAKPROC    0xD1
#define global EM_GETPASSWORDCHAR     0xD2 ;GfBbg Rg[̃pX[h擾
#define global EM_SETMARGINS          0xD3 ;eLXg{bNX̍Ẽ}[Wݒ
#define global EM_GETMARGINS          0xD4 ;sTextBoxɂāAẼ}[W擾
#define global EM_CHARFROMPOS         0xD7 ;NCAgWw肵āÄʒuɍł߂CfbNX擾
#define global EM_SETIMESTATUS        0xD8
#define global EM_GETIMESTATUS        0xD9

#define global EM_AUTOURLDETECT       0x45B
#define global EM_CANPASTE            0x432
#define global EM_CANREDO             0x455
#define global EM_CONVPOSITION        0x46C
#define global EM_DISPLAYBAND         0x433
#define global EM_EXGETSEL            0x434
#define global EM_EXLIMITTEXT         0x435
#define global EM_EXLINEFROMCHAR      0x436
#define global EM_EXSETSEL            0x437
#define global EM_FINDTEXT            0x438 ;
#define global EM_FINDTEXTEX          0x44F
#define global EM_FINDWORDBREAK       0x44C
#define global EM_FORMATRANGE         0x439
#define global EM_GETAUTOURLDETECT    0x45C
#define global EM_GETCHARFORMAT       0x43A
#define global EM_GETEVENTMASK        0x43B
#define global EM_GETIMECOLOR         0x469
#define global EM_GETIMECOMPMODE      0x47A
#define global EM_GETIMEOPTIONS       0x46B
#define global EM_GETLANGOPTIONS      0x479
#define global EM_GETLIMITTEXT        0x425 ;őeLXgʁij̎擾
#define global EM_GETOLEINTERFACE     0x43C
#define global EM_GETOPTIONS          0x44E
#define global EM_GETPARAFORMAT       0x43D
#define global EM_GETPUNCTUATION      0x465
#define global EM_GETREDONAME         0x457
#define global EM_GETSELTEXT          0x43E
#define global EM_GETTEXTEX           0x45E
#define global EM_GETTEXTLENGTHEX     0x45F
#define global EM_GETTEXTMODE         0x45A
#define global EM_GETTEXTRANGE        0x44B
#define global EM_GETUNDONAME         0x456
#define global EM_GETWORDBREAKPROCEX  0x450
#define global EM_GETWORDWRAPMODE     0x467
#define global EM_HIDESELECTION       0x43F
#define global EM_PASTESPECIAL        0x440
#define global EM_POSFROMCHAR         0x426
#define global EM_REDO                0x454
#define global EM_REQUESTRESIZE       0x441
#define global EM_SELECTIONTYPE       0x442
#define global EM_SETBKGNDCOLOR       0x443
#define global EM_SETCHARFORMAT       0x444
#define global EM_SETEVENTMASK        0x445
#define global EM_SETIMECOLOR         0x468
#define global EM_SETIMEOPTIONS       0x46A
#define global EM_SETLANGOPTIONS      0x478
#define global EM_SETOLECALLBACK      0x446
#define global EM_SETOPTIONS          0x44D
#define global EM_SETPALETTE          0x45D
#define global EM_SETPARAFORMAT       0x447
#define global EM_SETPUNCTUATION      0x464
#define global EM_SETTARGETDEVICE     0x448
#define global EM_SETTEXTMODE         0x459
#define global EM_SETUNDOLIMIT        0x452
#define global EM_SETWORDBREAKPROCEX  0x451
#define global EM_SETWORDWRAPMODE     0x466
#define global EM_STOPGROUPTYPING     0x458
#define global EM_STREAMIN            0x449
#define global EM_STREAMOUT           0x44A

#define global EN_SETFOCUS  0x0100; // ̓tH[JX𓾂
#define global EN_KILLFOCUS 0x0200; // ̓tH[JX
#define global EN_CHANGE    0x0300; // eLXgύXꂽ
#define global EN_UPDATE    0x0400; // eLXg̓eύX
#define global EN_ERRSPACE  0x0500; // obt@̃蓖ĂɎs
#define global EN_MAXTEXT   0x0501; // z
#define global EN_HSCROLL   0x0601; // XN[s
#define global EN_VSCROLL   0x0602; // XN[s

#module
#deffunc sjis_change var bufin, int flen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SJISR[h(sCR+LF)ɕϊ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

//gpϐ̐ݒ
sdim bufout,flen+1

i=0 : no=0
jis=0  : check=0
sjis=0 : s_chk=0
euc=0  : e_chk=0


//R[h𔻕ʂ
repeat flen
	//JIS`FbN
	a=peek(bufin,cnt) : if a=27 : jis=1 : break

	//EUC`FbN
	if e_chk/10>0 {
		e_chk=0 : if (a>160)&(a<255) : euc+=3
	} else {
		if e_chk\10>0 {
			if e_chk=1&(a>160)&(a<255) : euc+=2
			if e_chk=2&(a>160)&(a<224) : euc+=2
			if e_chk=3&(a>160)&(a<255) : e_chk=20
			if e_chk!20 : e_chk=0
		} else {
			if (a>160)&(a<255) : e_chk=1
			if (a=142)|(a=143) : e_chk=a-140
		}
	}

	//S-JIS`FbN
	if s_chk>0 {
		if (a> 64)&(a<126)|((a>127)&(a<253)) : sjis+=2
		s_chk=0
	} else {
		if (a>128)&(a<160)|((a>223)&(a<253)) : s_chk=1
	}
loop

if jis == 1 : goto *change_jis
if euc <= sjis : return "Shift-JIS"

//R[hϊ(euc --> s-jis)
*change_euc
	a=peek(bufin,no) : no++
	if( a >= 127 )&&( flen > no ){
		b=peek(bufin,no)

		//QoCg̕ϊ
		if a\2 == 0 : b-=0x02 : else : b-=0x61 : if b > 0x7e : b++

		//PoCg̕ϊ
		if a < 0xdf : a++ : a/=2 : a+=0x30 : else : a++ : a/=2 : a+=0x70

		wpoke bufin,no-1,(b<<8)+a : no++
	}
	if flen > no : goto *change_euc
	return "EUC"



//R[hϊ(jis --> s-jis)
*change_jis
	a=peek(bufin,no) : no++
	if a=27 {
		c=wpeek(bufin,no) : e=peek(bufin,no+2)
		f=wpeek(bufin,no+3) : no+=5
		if (c!16422)&(e!27)&(f!16932){
			no-=2
			if (c!10276)&(e!68){
				no--
				if (c!16936)&(c!18984)&(c!18728)&(c!16420)&(c!16932){
					no-=2 : goto *change_jis
				}
			}
		}
		if check>0 : check=0 : else : check=1
	} else {
		if check=1 {
			b=peek(bufin,no) : no++

			//QoCg̕ϊ
			if a\2 == 0 : b+=0x7d : else : b+=0x1f
			if b > 0x7e : b++

			//PoCg̕ϊ
			if a < 0x5f : a++ : a/=2 : a+=0x70 : else : a++ : a/=2 : a+=0xb0

			wpoke bufin,i,(b<<8)+a : i+=2
		} else {
			poke bufin,i,a : i++
		}
	}
	if flen > no : goto *change_jis
	memset bufin,0,flen-i,i
	return "JIS"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#global


#module
#deffunc kai_change var bufin, int flen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; s LF >> CR+LF ɕϊ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

//`FbN(s)쐬
CR="-" : poke CR,0,0x0D
LF="-" : poke LF,0,0x0A

if( instr(bufin,0,LF) < 0 )&&( instr(bufin,0,CR) < 0 ) : return

sdim buf,flen+1 : buf=bufin
bufin="" : notesel bufin

i=0
repeat flen
	a=instr(buf,i,CR) : if( a == -1 ): a=flen-i
	b=instr(buf,i,LF) : if( b == -1 ): b=flen-i

	if( a > b ) : a=b
	noteadd strmid(buf,i,a)

	i+=a+1 : if b == a+1 : i++
	if i >= flen : break
loop
return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#global

